Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/mm/as.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -2025,63 +1736,459 @@
  *
  */
-bool used_space_insert(used_space_t *used_space, uintptr_t page, size_t count)
-{
-	used_space_ival_t *a;
-	used_space_ival_t *b;
-	bool adj_a;
-	bool adj_b;
-	odlink_t *odlink;
-	used_space_ival_t *ival;
-
+bool used_space_insert(as_area_t *area, uintptr_t page, size_t count)
+{
+	assert(mutex_locked(&area->lock));
 	assert(IS_ALIGNED(page, PAGE_SIZE));
 	assert(count);
 
-	/* Interval to the left */
-	odlink = odict_find_lt(&used_space->ivals, &page, NULL);
-	a = (odlink != NULL) ?
-	    odict_get_instance(odlink, used_space_ival_t, lused_space) :
-	    NULL;
-
-	/* Interval to the right */
-	b = (a != NULL) ? used_space_next(a) :
-	    used_space_first(used_space);
-
-	/* Check for conflict with left interval */
-	if (a != NULL && overlaps(a->page, P2SZ(a->count), page, P2SZ(count)))
+	btree_node_t *leaf = NULL;
+	size_t pages = (size_t) btree_search(&area->used_space, page, &leaf);
+	if (pages) {
+		/*
+		 * We hit the beginning of some used space.
+		 */
 		return false;
-
-	/* Check for conflict with right interval */
-	if (b != NULL && overlaps(page, P2SZ(count), b->page, P2SZ(b->count)))
+	}
+
+	assert(leaf != NULL);
+
+	if (!leaf->keys) {
+		btree_insert(&area->used_space, page, (void *) count, leaf);
+		goto success;
+	}
+
+	btree_node_t *node = btree_leaf_node_left_neighbour(&area->used_space, leaf);
+	if (node) {
+		uintptr_t left_pg = node->key[node->keys - 1];
+		uintptr_t right_pg = leaf->key[0];
+		size_t left_cnt = (size_t) node->value[node->keys - 1];
+		size_t right_cnt = (size_t) leaf->value[0];
+
+		/*
+		 * Examine the possibility that the interval fits
+		 * somewhere between the rightmost interval of
+		 * the left neigbour and the first interval of the leaf.
+		 */
+
+		if (page >= right_pg) {
+			/* Do nothing. */
+		} else if (overlaps(page, P2SZ(count), left_pg,
+		    P2SZ(left_cnt))) {
+			/* The interval intersects with the left interval. */
+			return false;
+		} else if (overlaps(page, P2SZ(count), right_pg,
+		    P2SZ(right_cnt))) {
+			/* The interval intersects with the right interval. */
+			return false;
+		} else if ((page == left_pg + P2SZ(left_cnt)) &&
+		    (page + P2SZ(count) == right_pg)) {
+			/*
+			 * The interval can be added by merging the two already
+			 * present intervals.
+			 */
+			node->value[node->keys - 1] += count + right_cnt;
+			btree_remove(&area->used_space, right_pg, leaf);
+			goto success;
+		} else if (page == left_pg + P2SZ(left_cnt)) {
+			/*
+			 * The interval can be added by simply growing the left
+			 * interval.
+			 */
+			node->value[node->keys - 1] += count;
+			goto success;
+		} else if (page + P2SZ(count) == right_pg) {
+			/*
+			 * The interval can be addded by simply moving base of
+			 * the right interval down and increasing its size
+			 * accordingly.
+			 */
+			leaf->value[0] += count;
+			leaf->key[0] = page;
+			goto success;
+		} else {
+			/*
+			 * The interval is between both neigbouring intervals,
+			 * but cannot be merged with any of them.
+			 */
+			btree_insert(&area->used_space, page, (void *) count,
+			    leaf);
+			goto success;
+		}
+	} else if (page < leaf->key[0]) {
+		uintptr_t right_pg = leaf->key[0];
+		size_t right_cnt = (size_t) leaf->value[0];
+
+		/*
+		 * Investigate the border case in which the left neighbour does
+		 * not exist but the interval fits from the left.
+		 */
+
+		if (overlaps(page, P2SZ(count), right_pg, P2SZ(right_cnt))) {
+			/* The interval intersects with the right interval. */
+			return false;
+		} else if (page + P2SZ(count) == right_pg) {
+			/*
+			 * The interval can be added by moving the base of the
+			 * right interval down and increasing its size
+			 * accordingly.
+			 */
+			leaf->key[0] = page;
+			leaf->value[0] += count;
+			goto success;
+		} else {
+			/*
+			 * The interval doesn't adjoin with the right interval.
+			 * It must be added individually.
+			 */
+			btree_insert(&area->used_space, page, (void *) count,
+			    leaf);
+			goto success;
+		}
+	}
+
+	node = btree_leaf_node_right_neighbour(&area->used_space, leaf);
+	if (node) {
+		uintptr_t left_pg = leaf->key[leaf->keys - 1];
+		uintptr_t right_pg = node->key[0];
+		size_t left_cnt = (size_t) leaf->value[leaf->keys - 1];
+		size_t right_cnt = (size_t) node->value[0];
+
+		/*
+		 * Examine the possibility that the interval fits
+		 * somewhere between the leftmost interval of
+		 * the right neigbour and the last interval of the leaf.
+		 */
+
+		if (page < left_pg) {
+			/* Do nothing. */
+		} else if (overlaps(page, P2SZ(count), left_pg,
+		    P2SZ(left_cnt))) {
+			/* The interval intersects with the left interval. */
+			return false;
+		} else if (overlaps(page, P2SZ(count), right_pg,
+		    P2SZ(right_cnt))) {
+			/* The interval intersects with the right interval. */
+			return false;
+		} else if ((page == left_pg + P2SZ(left_cnt)) &&
+		    (page + P2SZ(count) == right_pg)) {
+			/*
+			 * The interval can be added by merging the two already
+			 * present intervals.
+			 */
+			leaf->value[leaf->keys - 1] += count + right_cnt;
+			btree_remove(&area->used_space, right_pg, node);
+			goto success;
+		} else if (page == left_pg + P2SZ(left_cnt)) {
+			/*
+			 * The interval can be added by simply growing the left
+			 * interval.
+			 */
+			leaf->value[leaf->keys - 1] += count;
+			goto success;
+		} else if (page + P2SZ(count) == right_pg) {
+			/*
+			 * The interval can be addded by simply moving base of
+			 * the right interval down and increasing its size
+			 * accordingly.
+			 */
+			node->value[0] += count;
+			node->key[0] = page;
+			goto success;
+		} else {
+			/*
+			 * The interval is between both neigbouring intervals,
+			 * but cannot be merged with any of them.
+			 */
+			btree_insert(&area->used_space, page, (void *) count,
+			    leaf);
+			goto success;
+		}
+	} else if (page >= leaf->key[leaf->keys - 1]) {
+		uintptr_t left_pg = leaf->key[leaf->keys - 1];
+		size_t left_cnt = (size_t) leaf->value[leaf->keys - 1];
+
+		/*
+		 * Investigate the border case in which the right neighbour
+		 * does not exist but the interval fits from the right.
+		 */
+
+		if (overlaps(page, P2SZ(count), left_pg, P2SZ(left_cnt))) {
+			/* The interval intersects with the left interval. */
+			return false;
+		} else if (left_pg + P2SZ(left_cnt) == page) {
+			/*
+			 * The interval can be added by growing the left
+			 * interval.
+			 */
+			leaf->value[leaf->keys - 1] += count;
+			goto success;
+		} else {
+			/*
+			 * The interval doesn't adjoin with the left interval.
+			 * It must be added individually.
+			 */
+			btree_insert(&area->used_space, page, (void *) count,
+			    leaf);
+			goto success;
+		}
+	}
+
+	/*
+	 * Note that if the algorithm made it thus far, the interval can fit
+	 * only between two other intervals of the leaf. The two border cases
+	 * were already resolved.
+	 */
+	btree_key_t i;
+	for (i = 1; i < leaf->keys; i++) {
+		if (page < leaf->key[i]) {
+			uintptr_t left_pg = leaf->key[i - 1];
+			uintptr_t right_pg = leaf->key[i];
+			size_t left_cnt = (size_t) leaf->value[i - 1];
+			size_t right_cnt = (size_t) leaf->value[i];
+
+			/*
+			 * The interval fits between left_pg and right_pg.
+			 */
+
+			if (overlaps(page, P2SZ(count), left_pg,
+			    P2SZ(left_cnt))) {
+				/*
+				 * The interval intersects with the left
+				 * interval.
+				 */
+				return false;
+			} else if (overlaps(page, P2SZ(count), right_pg,
+			    P2SZ(right_cnt))) {
+				/*
+				 * The interval intersects with the right
+				 * interval.
+				 */
+				return false;
+			} else if ((page == left_pg + P2SZ(left_cnt)) &&
+			    (page + P2SZ(count) == right_pg)) {
+				/*
+				 * The interval can be added by merging the two
+				 * already present intervals.
+				 */
+				leaf->value[i - 1] += count + right_cnt;
+				btree_remove(&area->used_space, right_pg, leaf);
+				goto success;
+			} else if (page == left_pg + P2SZ(left_cnt)) {
+				/*
+				 * The interval can be added by simply growing
+				 * the left interval.
+				 */
+				leaf->value[i - 1] += count;
+				goto success;
+			} else if (page + P2SZ(count) == right_pg) {
+				/*
+				 * The interval can be addded by simply moving
+				 * base of the right interval down and
+				 * increasing its size accordingly.
+				 */
+				leaf->value[i] += count;
+				leaf->key[i] = page;
+				goto success;
+			} else {
+				/*
+				 * The interval is between both neigbouring
+				 * intervals, but cannot be merged with any of
+				 * them.
+				 */
+				btree_insert(&area->used_space, page,
+				    (void *) count, leaf);
+				goto success;
+			}
+		}
+	}
+
+	panic("Inconsistency detected while adding %zu pages of used "
+	    "space at %p.", count, (void *) page);
+
+success:
+	area->resident += count;
+	return true;
+}
+
+/** Mark portion of address space area as unused.
+ *
+ * The address space area must be already locked.
+ *
+ * @param area  Address space area.
+ * @param page  First page to be marked.
+ * @param count Number of page to be marked.
+ *
+ * @return False on failure or true on success.
+ *
+ */
+bool used_space_remove(as_area_t *area, uintptr_t page, size_t count)
+{
+	assert(mutex_locked(&area->lock));
+	assert(IS_ALIGNED(page, PAGE_SIZE));
+	assert(count);
+
+	btree_node_t *leaf;
+	size_t pages = (size_t) btree_search(&area->used_space, page, &leaf);
+	if (pages) {
+		/*
+		 * We are lucky, page is the beginning of some interval.
+		 */
+		if (count > pages) {
+			return false;
+		} else if (count == pages) {
+			btree_remove(&area->used_space, page, leaf);
+			goto success;
+		} else {
+			/*
+			 * Find the respective interval.
+			 * Decrease its size and relocate its start address.
+			 */
+			btree_key_t i;
+			for (i = 0; i < leaf->keys; i++) {
+				if (leaf->key[i] == page) {
+					leaf->key[i] += P2SZ(count);
+					leaf->value[i] -= count;
+					goto success;
+				}
+			}
+
+			goto error;
+		}
+	}
+
+	btree_node_t *node = btree_leaf_node_left_neighbour(&area->used_space,
+	    leaf);
+	if ((node) && (page < leaf->key[0])) {
+		uintptr_t left_pg = node->key[node->keys - 1];
+		size_t left_cnt = (size_t) node->value[node->keys - 1];
+
+		if (overlaps(left_pg, P2SZ(left_cnt), page, P2SZ(count))) {
+			if (page + P2SZ(count) == left_pg + P2SZ(left_cnt)) {
+				/*
+				 * The interval is contained in the rightmost
+				 * interval of the left neighbour and can be
+				 * removed by updating the size of the bigger
+				 * interval.
+				 */
+				node->value[node->keys - 1] -= count;
+				goto success;
+			} else if (page + P2SZ(count) <
+			    left_pg + P2SZ(left_cnt)) {
+				size_t new_cnt;
+
+				/*
+				 * The interval is contained in the rightmost
+				 * interval of the left neighbour but its
+				 * removal requires both updating the size of
+				 * the original interval and also inserting a
+				 * new interval.
+				 */
+				new_cnt = ((left_pg + P2SZ(left_cnt)) -
+				    (page + P2SZ(count))) >> PAGE_WIDTH;
+				node->value[node->keys - 1] -= count + new_cnt;
+				btree_insert(&area->used_space, page +
+				    P2SZ(count), (void *) new_cnt, leaf);
+				goto success;
+			}
+		}
+
 		return false;
-
-	/* Check if A is adjacent to the new interval */
-	adj_a = (a != NULL) && (a->page + P2SZ(a->count) == page);
-	/* Check if the new interval is adjacent to B*/
-	adj_b = (b != NULL) && page + P2SZ(count) == b->page;
-
-	if (adj_a && adj_b) {
-		/* Fuse into a single interval */
-		a->count += count + b->count;
-		used_space_remove_ival(b);
-	} else if (adj_a) {
-		/* Append to A */
-		a->count += count;
-	} else if (adj_b) {
-		/* Prepend to B */
-		b->page = page;
-		b->count += count;
-	} else {
-		/* Create new interval */
-		ival = slab_alloc(used_space_ival_cache, 0);
-		ival->used_space = used_space;
-		odlink_initialize(&ival->lused_space);
-		ival->page = page;
-		ival->count = count;
-
-		odict_insert(&ival->lused_space, &used_space->ivals,
-		    NULL);
-	}
-
-	used_space->pages += count;
+	} else if (page < leaf->key[0])
+		return false;
+
+	if (page > leaf->key[leaf->keys - 1]) {
+		uintptr_t left_pg = leaf->key[leaf->keys - 1];
+		size_t left_cnt = (size_t) leaf->value[leaf->keys - 1];
+
+		if (overlaps(left_pg, P2SZ(left_cnt), page, P2SZ(count))) {
+			if (page + P2SZ(count) == left_pg + P2SZ(left_cnt)) {
+				/*
+				 * The interval is contained in the rightmost
+				 * interval of the leaf and can be removed by
+				 * updating the size of the bigger interval.
+				 */
+				leaf->value[leaf->keys - 1] -= count;
+				goto success;
+			} else if (page + P2SZ(count) < left_pg +
+			    P2SZ(left_cnt)) {
+				size_t new_cnt;
+
+				/*
+				 * The interval is contained in the rightmost
+				 * interval of the leaf but its removal
+				 * requires both updating the size of the
+				 * original interval and also inserting a new
+				 * interval.
+				 */
+				new_cnt = ((left_pg + P2SZ(left_cnt)) -
+				    (page + P2SZ(count))) >> PAGE_WIDTH;
+				leaf->value[leaf->keys - 1] -= count + new_cnt;
+				btree_insert(&area->used_space, page +
+				    P2SZ(count), (void *) new_cnt, leaf);
+				goto success;
+			}
+		}
+
+		return false;
+	}
+
+	/*
+	 * The border cases have been already resolved.
+	 * Now the interval can be only between intervals of the leaf.
+	 */
+	btree_key_t i;
+	for (i = 1; i < leaf->keys - 1; i++) {
+		if (page < leaf->key[i]) {
+			uintptr_t left_pg = leaf->key[i - 1];
+			size_t left_cnt = (size_t) leaf->value[i - 1];
+
+			/*
+			 * Now the interval is between intervals corresponding
+			 * to (i - 1) and i.
+			 */
+			if (overlaps(left_pg, P2SZ(left_cnt), page,
+			    P2SZ(count))) {
+				if (page + P2SZ(count) ==
+				    left_pg + P2SZ(left_cnt)) {
+					/*
+					 * The interval is contained in the
+					 * interval (i - 1) of the leaf and can
+					 * be removed by updating the size of
+					 * the bigger interval.
+					 */
+					leaf->value[i - 1] -= count;
+					goto success;
+				} else if (page + P2SZ(count) <
+				    left_pg + P2SZ(left_cnt)) {
+					size_t new_cnt;
+
+					/*
+					 * The interval is contained in the
+					 * interval (i - 1) of the leaf but its
+					 * removal requires both updating the
+					 * size of the original interval and
+					 * also inserting a new interval.
+					 */
+					new_cnt = ((left_pg + P2SZ(left_cnt)) -
+					    (page + P2SZ(count))) >>
+					    PAGE_WIDTH;
+					leaf->value[i - 1] -= count + new_cnt;
+					btree_insert(&area->used_space, page +
+					    P2SZ(count), (void *) new_cnt,
+					    leaf);
+					goto success;
+				}
+			}
+
+			return false;
+		}
+	}
+
+error:
+	panic("Inconsistency detected while removing %zu pages of used "
+	    "space from %p.", count, (void *) page);
+
+success:
+	area->resident -= count;
 	return true;
 }
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/mm/backend_anon.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -48,4 +48,5 @@
 #include <synch/mutex.h>
 #include <adt/list.h>
+#include <adt/btree.h>
 #include <errno.h>
 #include <typedefs.h>
@@ -121,32 +122,36 @@
 	 */
 	mutex_lock(&area->sh_info->lock);
-	used_space_ival_t *ival = used_space_first(&area->used_space);
-	while (ival != NULL) {
-		uintptr_t base = ival->page;
-		size_t count = ival->count;
-		unsigned int j;
-
-		for (j = 0; j < count; j++) {
-			pte_t pte;
-			bool found;
-
-			page_table_lock(area->as, false);
-			found = page_mapping_find(area->as, base + P2SZ(j),
-			    false, &pte);
-
-			(void)found;
-			assert(found);
-			assert(PTE_VALID(&pte));
-			assert(PTE_PRESENT(&pte));
-
-			as_pagemap_insert(&area->sh_info->pagemap,
-			    (base + P2SZ(j)) - area->base, PTE_GET_FRAME(&pte));
-			page_table_unlock(area->as, false);
-
-			pfn_t pfn = ADDR2PFN(PTE_GET_FRAME(&pte));
-			frame_reference_add(pfn);
+	list_foreach(area->used_space.leaf_list, leaf_link, btree_node_t,
+	    node) {
+		unsigned int i;
+
+		for (i = 0; i < node->keys; i++) {
+			uintptr_t base = node->key[i];
+			size_t count = (size_t) node->value[i];
+			unsigned int j;
+
+			for (j = 0; j < count; j++) {
+				pte_t pte;
+				bool found;
+
+				page_table_lock(area->as, false);
+				found = page_mapping_find(area->as,
+				    base + P2SZ(j), false, &pte);
+
+				(void)found;
+				assert(found);
+				assert(PTE_VALID(&pte));
+				assert(PTE_PRESENT(&pte));
+
+				btree_insert(&area->sh_info->pagemap,
+				    (base + P2SZ(j)) - area->base,
+				    (void *) PTE_GET_FRAME(&pte), NULL);
+				page_table_unlock(area->as, false);
+
+				pfn_t pfn = ADDR2PFN(PTE_GET_FRAME(&pte));
+				frame_reference_add(pfn);
+			}
+
 		}
-
-		ival = used_space_next(ival);
 	}
 	mutex_unlock(&area->sh_info->lock);
@@ -196,4 +201,6 @@
 	mutex_lock(&area->sh_info->lock);
 	if (area->sh_info->shared) {
+		btree_node_t *leaf;
+
 		/*
 		 * The area is shared, chances are that the mapping can be found
@@ -203,19 +210,33 @@
 		 * mapping, a new frame is allocated and the mapping is created.
 		 */
-		errno_t rc = as_pagemap_find(&area->sh_info->pagemap,
-		    upage - area->base, &frame);
-		if (rc != EOK) {
-			/* Need to allocate the frame */
-			kpage = km_temporary_page_get(&frame,
-			    FRAME_NO_RESERVE);
-			memsetb((void *) kpage, PAGE_SIZE, 0);
-			km_temporary_page_put(kpage);
+		frame = (uintptr_t) btree_search(&area->sh_info->pagemap,
+		    upage - area->base, &leaf);
+		if (!frame) {
+			bool allocate = true;
+			unsigned int i;
 
 			/*
-			 * Insert the address of the newly allocated
-			 * frame to the pagemap.
+			 * Zero can be returned as a valid frame address.
+			 * Just a small workaround.
 			 */
-			as_pagemap_insert(&area->sh_info->pagemap,
-			    upage - area->base, frame);
+			for (i = 0; i < leaf->keys; i++) {
+				if (leaf->key[i] == upage - area->base) {
+					allocate = false;
+					break;
+				}
+			}
+			if (allocate) {
+				kpage = km_temporary_page_get(&frame,
+				    FRAME_NO_RESERVE);
+				memsetb((void *) kpage, PAGE_SIZE, 0);
+				km_temporary_page_put(kpage);
+
+				/*
+				 * Insert the address of the newly allocated
+				 * frame to the pagemap.
+				 */
+				btree_insert(&area->sh_info->pagemap,
+				    upage - area->base, (void *) frame, leaf);
+			}
 		}
 		frame_reference_add(ADDR2PFN(frame));
@@ -259,5 +280,5 @@
 	 */
 	page_mapping_insert(AS, upage, frame, as_area_get_flags(area));
-	if (!used_space_insert(&area->used_space, upage, 1))
+	if (!used_space_insert(area, upage, 1))
 		panic("Cannot insert used space.");
 
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/mm/backend_elf.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -153,6 +153,6 @@
 {
 	elf_segment_header_t *entry = area->backend_data.segment;
-	used_space_ival_t *start;
-	used_space_ival_t *cur;
+	link_t *cur;
+	btree_node_t *leaf, *node;
 	uintptr_t start_anon = entry->p_vaddr + entry->p_filesz;
 
@@ -164,8 +164,11 @@
 	 */
 	if (area->flags & AS_AREA_WRITE) {
-		start = used_space_first(&area->used_space);
+		node = list_get_instance(list_first(&area->used_space.leaf_list),
+		    btree_node_t, leaf_link);
 	} else {
-		/* Find first interval containing addresses >= start_anon */
-		start = used_space_find_gteq(&area->used_space, start_anon);
+		(void) btree_search(&area->used_space, start_anon, &leaf);
+		node = btree_leaf_node_left_neighbour(&area->used_space, leaf);
+		if (!node)
+			node = leaf;
 	}
 
@@ -174,53 +177,57 @@
 	 */
 	mutex_lock(&area->sh_info->lock);
-	cur = start;
-	while (cur != NULL) {
-		uintptr_t base = cur->page;
-		size_t count = cur->count;
+	for (cur = &node->leaf_link; cur != &area->used_space.leaf_list.head;
+	    cur = cur->next) {
 		unsigned int i;
 
-		/*
-		 * Skip read-only areas of used space that are backed
-		 * by the ELF image.
-		 */
-		if (!(area->flags & AS_AREA_WRITE))
-			if (base >= entry->p_vaddr &&
-			    base + P2SZ(count) <= start_anon)
-				continue;
-
-		for (i = 0; i < count; i++) {
-			pte_t pte;
-			bool found;
+		node = list_get_instance(cur, btree_node_t, leaf_link);
+
+		for (i = 0; i < node->keys; i++) {
+			uintptr_t base = node->key[i];
+			size_t count = (size_t) node->value[i];
+			unsigned int j;
 
 			/*
-			 * Skip read-only pages that are backed by the
-			 * ELF image.
+			 * Skip read-only areas of used space that are backed
+			 * by the ELF image.
 			 */
 			if (!(area->flags & AS_AREA_WRITE))
 				if (base >= entry->p_vaddr &&
-				    base + P2SZ(i + 1) <= start_anon)
+				    base + P2SZ(count) <= start_anon)
 					continue;
 
-			page_table_lock(area->as, false);
-			found = page_mapping_find(area->as,
-			    base + P2SZ(i), false, &pte);
-
-			(void) found;
-			assert(found);
-			assert(PTE_VALID(&pte));
-			assert(PTE_PRESENT(&pte));
-
-			as_pagemap_insert(&area->sh_info->pagemap,
-			    (base + P2SZ(i)) - area->base,
-			    PTE_GET_FRAME(&pte));
-			page_table_unlock(area->as, false);
-
-			pfn_t pfn = ADDR2PFN(PTE_GET_FRAME(&pte));
-			frame_reference_add(pfn);
-		}
-
-		cur = used_space_next(cur);
-	}
-
+			for (j = 0; j < count; j++) {
+				pte_t pte;
+				bool found;
+
+				/*
+				 * Skip read-only pages that are backed by the
+				 * ELF image.
+				 */
+				if (!(area->flags & AS_AREA_WRITE))
+					if (base >= entry->p_vaddr &&
+					    base + P2SZ(j + 1) <= start_anon)
+						continue;
+
+				page_table_lock(area->as, false);
+				found = page_mapping_find(area->as,
+				    base + P2SZ(j), false, &pte);
+
+				(void) found;
+				assert(found);
+				assert(PTE_VALID(&pte));
+				assert(PTE_PRESENT(&pte));
+
+				btree_insert(&area->sh_info->pagemap,
+				    (base + P2SZ(j)) - area->base,
+				    (void *) PTE_GET_FRAME(&pte), NULL);
+				page_table_unlock(area->as, false);
+
+				pfn_t pfn = ADDR2PFN(PTE_GET_FRAME(&pte));
+				frame_reference_add(pfn);
+			}
+
+		}
+	}
 	mutex_unlock(&area->sh_info->lock);
 }
@@ -260,4 +267,5 @@
 	elf_header_t *elf = area->backend_data.elf;
 	elf_segment_header_t *entry = area->backend_data.segment;
+	btree_node_t *leaf;
 	uintptr_t base;
 	uintptr_t frame;
@@ -293,15 +301,31 @@
 	mutex_lock(&area->sh_info->lock);
 	if (area->sh_info->shared) {
+		bool found = false;
+
 		/*
 		 * The address space area is shared.
 		 */
 
-		errno_t rc = as_pagemap_find(&area->sh_info->pagemap,
-		    upage - area->base, &frame);
-		if (rc == EOK) {
+		frame = (uintptr_t) btree_search(&area->sh_info->pagemap,
+		    upage - area->base, &leaf);
+		if (!frame) {
+			unsigned int i;
+
+			/*
+			 * Workaround for valid NULL address.
+			 */
+
+			for (i = 0; i < leaf->keys; i++) {
+				if (leaf->key[i] == upage - area->base) {
+					found = true;
+					break;
+				}
+			}
+		}
+		if (frame || found) {
 			frame_reference_add(ADDR2PFN(frame));
 			page_mapping_insert(AS, upage, frame,
 			    as_area_get_flags(area));
-			if (!used_space_insert(&area->used_space, upage, 1))
+			if (!used_space_insert(area, upage, 1))
 				panic("Cannot insert used space.");
 			mutex_unlock(&area->sh_info->lock);
@@ -391,6 +415,6 @@
 	if (dirty && area->sh_info->shared) {
 		frame_reference_add(ADDR2PFN(frame));
-		as_pagemap_insert(&area->sh_info->pagemap, upage - area->base,
-		    frame);
+		btree_insert(&area->sh_info->pagemap, upage - area->base,
+		    (void *) frame, leaf);
 	}
 
@@ -398,5 +422,5 @@
 
 	page_mapping_insert(AS, upage, frame, as_area_get_flags(area));
-	if (!used_space_insert(&area->used_space, upage, 1))
+	if (!used_space_insert(area, upage, 1))
 		panic("Cannot insert used space.");
 
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/mm/backend_phys.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -143,5 +143,5 @@
 	    as_area_get_flags(area));
 
-	if (!used_space_insert(&area->used_space, upage, 1))
+	if (!used_space_insert(area, upage, 1))
 		panic("Cannot insert used space.");
 
Index: kernel/generic/src/mm/backend_user.c
===================================================================
--- kernel/generic/src/mm/backend_user.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/mm/backend_user.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -147,5 +147,5 @@
 	uintptr_t frame = IPC_GET_ARG1(data);
 	page_mapping_insert(AS, upage, frame, as_area_get_flags(area));
-	if (!used_space_insert(&area->used_space, upage, 1))
+	if (!used_space_insert(area, upage, 1))
 		panic("Cannot insert used space.");
 
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/proc/task.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -269,5 +269,5 @@
 {
 	/*
-	 * Remove the task from the task odict.
+	 * Remove the task from the task B+tree.
 	 */
 	irq_spinlock_lock(&tasks_lock, true);
Index: kernel/generic/src/sysinfo/stats.c
===================================================================
--- kernel/generic/src/sysinfo/stats.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/src/sysinfo/stats.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -189,5 +189,5 @@
 			continue;
 
-		pages += area->used_space.pages;
+		pages += area->resident;
 		mutex_unlock(&area->lock);
 		area = as_area_next(area);
Index: kernel/test/btree/btree1.c
===================================================================
--- kernel/test/btree/btree1.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
+++ kernel/test/btree/btree1.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -0,0 +1,161 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <test.h>
+#include <adt/btree.h>
+
+static void *data = (void *) 0xdeadbeef;
+
+const char *test_btree1(void)
+{
+	btree_t t;
+	int i;
+
+	btree_create(&t);
+
+	TPRINTF("Inserting keys.\n");
+	btree_insert(&t, 19, data, NULL);
+	btree_insert(&t, 20, data, NULL);
+	btree_insert(&t, 21, data, NULL);
+	btree_insert(&t, 0, data, NULL);
+	btree_insert(&t, 25, data, NULL);
+	btree_insert(&t, 22, data, NULL);
+	btree_insert(&t, 26, data, NULL);
+	btree_insert(&t, 23, data, NULL);
+	btree_insert(&t, 24, data, NULL);
+	btree_insert(&t, 5, data, NULL);
+	btree_insert(&t, 1, data, NULL);
+	btree_insert(&t, 4, data, NULL);
+	btree_insert(&t, 28, data, NULL);
+	btree_insert(&t, 29, data, NULL);
+	btree_insert(&t, 7, data, NULL);
+	btree_insert(&t, 8, data, NULL);
+	btree_insert(&t, 9, data, NULL);
+	btree_insert(&t, 17, data, NULL);
+	btree_insert(&t, 18, data, NULL);
+	btree_insert(&t, 2, data, NULL);
+	btree_insert(&t, 3, data, NULL);
+	btree_insert(&t, 6, data, NULL);
+	btree_insert(&t, 10, data, NULL);
+	btree_insert(&t, 11, data, NULL);
+	btree_insert(&t, 12, data, NULL);
+	btree_insert(&t, 13, data, NULL);
+	btree_insert(&t, 14, data, NULL);
+	btree_insert(&t, 15, data, NULL);
+	btree_insert(&t, 16, data, NULL);
+	btree_insert(&t, 27, data, NULL);
+
+	for (i = 30; i < 50; i++)
+		btree_insert(&t, i, data, NULL);
+	for (i = 100; i >= 50; i--)
+		btree_insert(&t, i, data, NULL);
+
+	if (!test_quiet)
+		btree_print(&t);
+
+	TPRINTF("Removing keys.\n");
+	btree_remove(&t, 50, NULL);
+	btree_remove(&t, 49, NULL);
+	btree_remove(&t, 51, NULL);
+	btree_remove(&t, 46, NULL);
+	btree_remove(&t, 45, NULL);
+	btree_remove(&t, 48, NULL);
+	btree_remove(&t, 53, NULL);
+	btree_remove(&t, 47, NULL);
+	btree_remove(&t, 52, NULL);
+	btree_remove(&t, 54, NULL);
+	btree_remove(&t, 65, NULL);
+	btree_remove(&t, 60, NULL);
+	btree_remove(&t, 99, NULL);
+	btree_remove(&t, 97, NULL);
+	btree_remove(&t, 57, NULL);
+	btree_remove(&t, 58, NULL);
+	btree_remove(&t, 61, NULL);
+	btree_remove(&t, 64, NULL);
+	btree_remove(&t, 56, NULL);
+	btree_remove(&t, 41, NULL);
+
+	for (i = 5; i < 20; i++)
+		btree_remove(&t, i, NULL);
+
+	btree_remove(&t, 2, NULL);
+	btree_remove(&t, 43, NULL);
+	btree_remove(&t, 22, NULL);
+	btree_remove(&t, 100, NULL);
+	btree_remove(&t, 98, NULL);
+	btree_remove(&t, 96, NULL);
+	btree_remove(&t, 66, NULL);
+	btree_remove(&t, 1, NULL);
+
+	for (i = 70; i < 90; i++)
+		btree_remove(&t, i, NULL);
+
+	btree_remove(&t, 20, NULL);
+	btree_remove(&t, 0, NULL);
+	btree_remove(&t, 40, NULL);
+	btree_remove(&t, 3, NULL);
+	btree_remove(&t, 4, NULL);
+	btree_remove(&t, 21, NULL);
+	btree_remove(&t, 44, NULL);
+	btree_remove(&t, 55, NULL);
+	btree_remove(&t, 62, NULL);
+	btree_remove(&t, 26, NULL);
+	btree_remove(&t, 27, NULL);
+	btree_remove(&t, 28, NULL);
+	btree_remove(&t, 29, NULL);
+	btree_remove(&t, 30, NULL);
+	btree_remove(&t, 31, NULL);
+	btree_remove(&t, 32, NULL);
+	btree_remove(&t, 33, NULL);
+	btree_remove(&t, 93, NULL);
+	btree_remove(&t, 95, NULL);
+	btree_remove(&t, 94, NULL);
+	btree_remove(&t, 69, NULL);
+	btree_remove(&t, 68, NULL);
+	btree_remove(&t, 92, NULL);
+	btree_remove(&t, 91, NULL);
+	btree_remove(&t, 67, NULL);
+	btree_remove(&t, 63, NULL);
+	btree_remove(&t, 90, NULL);
+	btree_remove(&t, 59, NULL);
+	btree_remove(&t, 23, NULL);
+	btree_remove(&t, 24, NULL);
+	btree_remove(&t, 25, NULL);
+	btree_remove(&t, 37, NULL);
+	btree_remove(&t, 38, NULL);
+	btree_remove(&t, 42, NULL);
+	btree_remove(&t, 39, NULL);
+	btree_remove(&t, 34, NULL);
+	btree_remove(&t, 35, NULL);
+	btree_remove(&t, 36, NULL);
+
+	if (!test_quiet)
+		btree_print(&t);
+
+	return NULL;
+}
Index: kernel/test/btree/btree1.def
===================================================================
--- kernel/test/btree/btree1.def	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
+++ kernel/test/btree/btree1.def	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -0,0 +1,6 @@
+{
+	"btree1",
+	"Test B-tree operations",
+	&test_btree1,
+	true
+},
